#! /usr/bin/env lua

-- Hello World

require("lgui")
require("ldraw")

function expose(widget)
	local cr = ldraw.Context.createFromDrawable(widget:getWindow())
	local width, height = widget:getSize()

	-- Clear
	cr:setSourceRgb(1, 1, 1)
	cr:paint()

	-- Draw a rectangle
	cr:rectangle(20, 20, width - 40, height - 40)
	cr:setSourceRgb(0, 0, 0)
	cr:fill()

	-- Paint all
	cr:setSourceRgb(0, 0, 1)
	cr:paintWithAlpha(0.3)

	cr:destroy()
end

local window = lgui.Window.new()
window:set("title", "Alpha painting", "window-position", lgui.WIN_POS_CENTER,
"app-paintable", true)

window:showAll()
window:connect("delete-event", lgui.quit)
window:connect("expose-event", expose, window)
window:connect("size-allocate", expose, window)

lgui.main()
