#! /usr/bin/env lua

-- From http://zetcode.com/tutorials/cairographicstutorial/transformations/

require("lgui")
require("ldraw")

local matrix = ldraw.Matrix.create()

function expose(widget)
	local cr = ldraw.Context.createFromDrawable(widget:getWindow())

	cr:save()
	cr:setSourceRgb(0.6, 0.6, 0.6)
	cr:rectangle(20, 30, 80, 50)
	cr:fillPreserve()
	cr:setSourceRgb(0, 0, 1)
	cr:stroke()
	cr:restore()

	cr:translate(80, 50)
	matrix:init(1, 0.5, 0, 1, 0, 0)
	cr:transform(matrix)

	cr:setSourceRgb(0.6, 0.6, 0.6)
	cr:rectangle(20, 30, 80, 50)
	cr:fillPreserve()
	cr:setSourceRgb(0, 0, 1)
	cr:stroke()
	cr:destroy()
end

local window = lgui.Window.new()
window:set("title", "Hello World", "window-position", lgui.WIN_POS_CENTER,
"app-paintable", true)

window:connect("delete-event", lgui.quit)
window:connect("expose-event", expose, window)

window:showAll()
lgui.main()

matrix:destroy()
